%% ---------- define a finite difference matrix 
%% ---------- with a zero convection term (A=A')
close 
addpath ../sparse
A = fd3d(25, 25, 1, 0.0, 0.0, 0., 0);
%% ---------- dimension of A 
n = size(A,1);
%% ---------- right-hand side
b = A*ones(n,1);
%%---------- call sdescent 
tic
[x, r1] = steep(A, b, zeros(n,1), 200); 
toc
%%---------- call MR 
tic
[x, r2] = mr(A, b, zeros(n,1), 200) ;
toc 
%%---------- call rn descent
tic
[x, r3] = rndescent(A,b, zeros(n,1), 200) ;
toc 
%%---------- Gauss_seidel
tic
[x, r4] = gs(A, b, 200, 0.0, zeros(n,1));
toc
%%
%%---------- plot 4 residual curves..  
h1=semilogy([1:length(r1)],r1,'k-',[1:length(r2)],r2,'b--', ...
	    [1:length(r3)],r3,'r-.',[1:length(r4)],r4,'m');
set(h1,'linewidth',2)
h1 = legend('Steepest descent','Min-Res','ResNormSpeepD','Gauss-Seidel') ;
set(h1,'fontsize',16,'location','southwest') 
