function [rs,x] = gcr (A, b, x0, m, tol) 
% gcr (A, b, x0, m, tol)   - no restarts
% solves Ax = b by m steps of GCR
%%-----------------------------------------------
n  = size(A,1);
 x  = x0;
 r  = b - A*x;
 p  = r;  
 P  = p;
 Ap = A*p;
 t  = norm(Ap);
 p  = p/ t; 
 Ap = Ap/t;
 AP = Ap;
 rs(1) = norm(r,2);
 ro = rs(1);
 for i=2:m
    alp = (r'*Ap) ;
    x   = x + alp*p;
    r   = r - alp*Ap;
    Ar  = A*r;
    bet = AP'*Ar;
    p   = r - P*bet;
    Ap  = Ar - AP*bet;
    t   = norm(Ap);
    p   = p / t;
    Ap  = Ap / t;
  rs(i) = norm(r) ;
%% test for convergence
    if (abs(rs(i)) < tol*ro) 
       break
    end
    P = [P,p];
    AP = [AP,Ap]; 
end  
